MrSID Decode SDK for Raster Reference Manual 9.5.4.4709

- Main Page
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
LTIEmbeddedImage Class Reference

create a larger frame for the image More...

`#include <lti_embeddedImage.h>`

Inheritance diagram for LTIEmbeddedImage:
[legend]
Collaboration diagram for LTIEmbeddedImage:
[legend]

## Public Types
enum | AlphaMode { DoNothing, FromMerge, FromSourceRectangle }

## Public Member Functions
LT_STATUS | initialize (LTIImageStage *srcImage, lt_uint32 newWidth, lt_uint32 newHeight, double newXPos, double newYPos, const LTIPixel *backgroundPixel, const LTIPixel *nodataPixel, AlphaMode alphaMode=DoNothing)
| initialize More...
LT_STATUS | getDimsAtMag (double mag, lt_uint32 &width, lt_uint32 &height) const
| get image width and height at given magnification More...
lt_int64 | getEncodingCost (const LTIScene &scene) const
| get the cost to encode this scene More...
bool | getReaderScene (const LTIScene &decodeScene, LTIScene &readerScene) const
| get the underlying scene to be used More...
LT_STATUS | setFillingBackground (bool fill)
| control whether or not the background of the new "outer" image should be filled More...
bool | getFillingBackground (void) const
| query whether or not the background of the new "outer" image should be filled More...
LT_STATUS | setFillMethod (LTIPixelFillMethod method, double fuzzyThreshold)
| Set the fill method which controls how noData pixels are matched. More...
LTIPixelFillMethod | getFillMethod (void) const
| Get the fill method. More...
double | getFuzzyThreshold (void) const
virtual lt_uint32 | getModifications (const LTIScene &scene) const
| get the modification bitfield for this image More...
lt_int32 | getChildXPosAtMag (double mag) const
lt_int32 | getChildYPosAtMag (double mag) const
bool | getChildScene (const LTIScene &parentScene, LTIScene &childScene) const
Public Member Functions inherited from LTIOverrideDimensions< LTIOverridePixelProps< LTIOverrideBackgroundPixel< LTIOverrideGeoCoord< LTIImageFilter > > > >
lt_uint32 | getWidth () const
| get image width More...
lt_uint32 | getHeight () const
| get image height More...
Public Member Functions inherited from LTIOverridePixelProps< LTIOverrideBackgroundPixel< LTIOverrideGeoCoord< LTIImageFilter > > >
const LTIPixel & | getPixelProps () const
| get the pixel properties of the image More...
const LTIPixel & | getMinDynamicRange () const
| get the minimum dynamic range value of image More...
const LTIPixel & | getMaxDynamicRange () const
| get the maximum dynamic range value of image More...
LT_STATUS | overridePixelBPS (lt_uint8 bps)
| override the bits-per-sample of the image's (sample's) datatype More...
LT_STATUS | overrideDynamicRange (const LTIPixel &drmin, const LTIPixel &drmax)
| override the dynamic range of the image More...
Public Member Functions inherited from LTIOverrideBackgroundPixel< LTIOverrideGeoCoord< LTIImageFilter > >
const LTIPixel * | getBackgroundPixel () const
| get the values of the background pixel More...
const LTIPixel * | getNoDataPixel () const
| get the values of the "no data" (transparency) pixel More...
LT_STATUS | overrideBackgroundPixel (const LTIPixel *backgroundPixel)
| override the background color of the image More...
LT_STATUS | overrideNoDataPixel (const LTIPixel *nodataPixel)
| override the "no data" (transparency) color of the image More...
Public Member Functions inherited from LTIOverrideGeoCoord< LTIImageFilter >
const LTIGeoCoord & | getGeoCoord () const
| get the geographic coordinates of the image More...
bool | isGeoCoordImplicit () const
| is geo information "real" or not More...
LT_STATUS | overrideGeoCoord (const LTIGeoCoord &geoCoord)
| override the geographic coordinates of the image More...
Public Member Functions inherited from LTIImageFilter
LT_STATUS | getDimsAtMag (double mag, lt_uint32 &width, lt_uint32 &height) const
| get image width and height at given magnification More...
const LTIPixelLookupTable * | getPixelLookupTable () const
| get the color lookup table, if any More...
const LTIMetadataDatabase & | getMetadata () const
| get the metadata associated with the image More...
double | getMinMagnification () const
| get the minimum magnification More...
double | getMaxMagnification () const
| get the maximum magnification More...
bool | isSelective () const
| check if image supports "random access" decoding More...
lt_uint32 | getModifications (const LTIScene &scene) const
| get the modification bitfield for this image More...
LT_STATUS | getMetadataBlob (const char *type, LTIOStreamInf *&stream) const
| extract the metadata associated with the image of the given type More...
void | setProgressDelegate (LTIProgressDelegate *delegate)
| set progress delegate More...
LTIProgressDelegate * | getProgressDelegate () const
| get progress delegate More...
void | setInterruptDelegate (LTIInterruptDelegate *delegate)
| set interrupt delegate More...
LTIInterruptDelegate * | getInterruptDelegate () const
| get interrupt delegate More...
lt_uint32 | getStripHeight () const
| get strip height More...
LT_STATUS | setStripHeight (lt_uint32 stripHeight)
| set the strip height More...
lt_int64 | getEncodingCost (const LTIScene &scene) const
| get the cost to encode this scene More...
bool | getReaderScene (const LTIScene &decodeScene, LTIScene &readerScene) const
| get the underlying scene to be used More...
LT_STATUS | overridePixelLookupTable (const LTIPixelLookupTable *pixelLookupTable)
| override the CLUT of the image More...
LT_STATUS | overrideMetadata (const LTIMetadataDatabase &metadata)
| override the metadata of the image More...
LTIMaskSource * | getMask () const
bool | getPipelineInfo (LTIPipelineInfo info) const
LTIImageStage * | getPreviousStage (void) const
Public Member Functions inherited from LTIImageStage
LT_STATUS | read (const LTIScene &scene, LTISceneBuffer &buffer)
| read (decode) a scene from the image More...
virtual LT_STATUS | readBegin (const LTIPixel &pixelProps, const LTIScene &fullScene)
| start strip-based read More...
virtual LT_STATUS | readStrip (LTISceneBuffer &buffer, const LTIScene &stripScene)
| read a strip from the image More...
virtual LT_STATUS | readEnd ()
| finish strip-based read More...
lt_uint32 | getNumStrips () const
| get number of strips in scene More...
LTIScene | getStripScene (lt_uint32 stripNumber) const
| get a strip for current scene More...
Public Member Functions inherited from LTIImage
lt_uint16 | getNumBands () const
| get number of bands More...
lt_uint16 | getNumBandsWithoutAlpha () const
| get number of bands without alpha More...
LTIColorSpace | getColorSpace () const
| get colorspace More...
LTIDataType | getDataType () const
| get data type More...
bool | isNaturalDynamicRange () const
| check if the range is "complete" or not More...
lt_int64 | getNominalImageSizeWithoutAlpha () const
| get the nominal size of the image, not considering the alpha band More...
lt_int64 | getNominalImageSizeWithAlpha () const
| get the nominal size of the image, including the alpha band More...
void | getGeoPoint (LTIPosition position, double &x, double &y) const
| get position of a named point More...
LTIPixel * | createBackgroundPixel () const
| return new background pixel More...
Public Member Functions inherited from LTIReferenceCountedObject
virtual void | retain (void) const
| increment reference counter More...
virtual void | release (void) const
| decrement the reference counter and delete the object when the counter is zero More...

## Static Public Member Functions
static LTIEmbeddedImage * | create (void)
static LT_STATUS | push (LTIImageStage *&pipeline, LTIScene &scene, const LTIPixel *backgroundPixel=NULL)

## Protected Member Functions
| LTIEmbeddedImage (void)
virtual | ~LTIEmbeddedImage (void)
LT_STATUS | decodeBegin (const LTIPixel &pixelProps, const LTIScene &fullScene)
| start strip-based read More...
LT_STATUS | decodeStrip (LTISceneBuffer &stripBuffer, const LTIScene &stripScene)
| read a strip from the image More...
LT_STATUS | decodeEnd (void)
| finish strip-based read More...

## Additional Inherited Members
Protected Attributes inherited from LTIOverrideGeoCoordData
LTIGeoCoord * | m_geoCoord
bool | m_geoCoordImplicit
Protected Attributes inherited from LTIOverrideBackgroundPixelData
LTIPixel * | m_backgroundPixel
LTIPixel * | m_nodataPixel
Protected Attributes inherited from LTIOverridePixelPropsData
LTIPixel * | m_pixelProps
LTIPixel * | m_drminPixel
LTIPixel * | m_drmaxPixel
Protected Attributes inherited from LTIOverrideDimensionsData
lt_uint32 | m_width
lt_uint32 | m_height

## Detailed Description

Creates a new image stage of the given size, containing the input image stage within it.

This class is used to make an image stage "larger", e.g. to place an image on a larger "canvas" for more flexible decoding. This class is used by the LTIMosaicFilter class to simplify certain computations by making all the input images map to the same underlying grid shape and size.

The embedding process honors the background and nodata pixel settings.

The LTIGeoCoord information for the image stage is updated appropriately.

Definition at line 42 of file lti_embeddedImage.h.

## Member Enumeration Documentation

enum LTIEmbeddedImage::AlphaMode

Enumerator
DoNothing |
FromMerge |
FromSourceRectangle |

Definition at line 51 of file lti_embeddedImage.h.

## Constructor & Destructor Documentation

LTIEmbeddedImage::LTIEmbeddedImage | ( | void | ) |  |
| protected

virtual LTIEmbeddedImage::~LTIEmbeddedImage | ( | void | ) |  |
| protected virtual

## Member Function Documentation

static LTIEmbeddedImage* LTIEmbeddedImage::create | ( | void | ) |  |
| static

LT_STATUS LTIEmbeddedImage::decodeBegin | ( | const LTIPixel & | pixelProps,
|  | const LTIScene & | fullScene
| ) |  |
| protected virtual

This function is called by readBegin() to start the actual class-specific work for decoding a scene.

Derived classes must implement this function.

This function should never be called directly.

Parameters

  pixelProps | the band selection
  fullScene | the full scene to be read

Returns
  status code indicating success or failure

Implements LTIImageStage.

LT_STATUS LTIEmbeddedImage::decodeEnd | ( | void | ) |  |
| protected virtual

This function is called by readEnd() to complete the actual class-specific work for decoding a scene.

Derived classes must implement this function.

This function should never be called directly.

Returns
  status code indicating success or failure

Implements LTIImageStage.

LT_STATUS LTIEmbeddedImage::decodeStrip | ( | LTISceneBuffer & | stripBuffer,
|  | const LTIScene & | stripScene
| ) |  |
| protected virtual

This function is called by readStrip() to implement the actual class-specific work for decoding a strip of the scene.

Derived classes must implement this function.

This function should never be called directly.

Parameters

  stripBuffer | the buffer to read the pixels into
  stripScene | the scene for this strip being decoded

Returns
  status code indicating success or failure

Implements LTIImageStage.

bool LTIEmbeddedImage::getChildScene | ( | const LTIScene & | parentScene,
|  | LTIScene & | childScene
| ) |  | const

lt_int32 LTIEmbeddedImage::getChildXPosAtMag | ( | double | mag) |  | const

lt_int32 LTIEmbeddedImage::getChildYPosAtMag | ( | double | mag) |  | const

LT_STATUS LTIEmbeddedImage::getDimsAtMag | ( | double | mag,
|  | lt_uint32 & | width,
|  | lt_uint32 & | height
| ) |  | const
| virtual

This function returns the width and height of the image, in pixels, relative to the given magnification.

Parameters

  mag | magnification to determine width at
  width | the image width at the magnification
  height | the image height at the magnification

Returns
  status code indicating success or failure

Implements LTIImage.

lt_int64 LTIEmbeddedImage::getEncodingCost | ( | const LTIScene & | scene) |  | const
| virtual

Returns the "cost" to encode this scene, for use by those image writers which have usage metering enabled. The typical cost is equal to the nominal image size (width * height * numBands * bytesPerSample), but this is overridden for special situations, e.g. the mosaic filter.

Parameters

  scene | the scene to be charged for

Returns
  the cost to encode the given scene

Implements LTIImageStage.

bool LTIEmbeddedImage::getFillingBackground | ( | void | ) |  | const

Returns
  true if background to be filled

LTIPixelFillMethod LTIEmbeddedImage::getFillMethod | ( | void | ) |  | const

See setFillMethod().

double LTIEmbeddedImage::getFuzzyThreshold | ( | void | ) |  | const

virtual lt_uint32 LTIEmbeddedImage::getModifications | ( | const LTIScene & | scene) |  | const
| virtual

This function returns a bitfield describing what kinds of modifications have been made to the image during and since its initial encoding.

Parameters

  scene | the area pertaining to this request

Returns
  a bitfield itemizing the encoding modifications

Implements LTIImage.

bool LTIEmbeddedImage::getReaderScene | ( | const LTIScene & | decodeScene,
|  | LTIScene & | readerScene
| ) |  | const
| virtual

Get the scene that will be sent to the underlying LTIImageReader. This is useful in some complex pipelines.

Parameters

  decodeScene | the scene that would be given to read()
  readerScene | the scene that is the actual scene passed the underlying image reader

Returns
  true if readerScene is not empty

Implements LTIImageStage.

LT_STATUS LTIEmbeddedImage::initialize | ( | LTIImageStage * | srcImage,
|  | lt_uint32 | newWidth,
|  | lt_uint32 | newHeight,
|  | double | newXPos,
|  | double | newYPos,
|  | const LTIPixel * | backgroundPixel,
|  | const LTIPixel * | nodataPixel,
|  | AlphaMode | alphaMode = `DoNothing`
| ) |  |

Creates an image stage whose input image is placed within a much larger empty canvas.

Parameters

  srcImage | the base image
  newWidth | the width of the new image stage
  newHeight | the height of the new image stage
  newXPos | pixel x-position of the input image in the new image
  newYPos | pixel y-position of the input image in the new image
  backgroundPixel | background pixel color to use for the new image (may be NULL, in which case the input image's background is used)
  nodataPixel | nodata pixel color to use for the new image (may be NULL, in which case the input image's nodata is used)
  fakeAlphaBand | set to true to force this filter to pretend it has an alpha band

static LT_STATUS LTIEmbeddedImage::push | ( | LTIImageStage *& | pipeline,
|  | LTIScene & | scene,
|  | const LTIPixel * | backgroundPixel = `NULL`
| ) |  |
| static

LT_STATUS LTIEmbeddedImage::setFillingBackground | ( | bool | fill) |  |

Parameters

  fill | set to true to fill the background

Returns
  success or failure

LT_STATUS LTIEmbeddedImage::setFillMethod | ( | LTIPixelFillMethod | method,
|  | double | fuzzyThreshold
| ) |  |

Parameters

  method | fill method enum. See LTIPixelFillMethod
  fuzzyThreshold | fill method enum. See LTIPixelFillMethod

The documentation for this class was generated from the following file:

- lti_embeddedImage.h

LizardTech